"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
var ink_1 = require("ink");
var React = require("react");
var shortcutInfos = {
    up: React.createElement(ink_1.Color, { blue: true }, "\u25B2 "),
    down: React.createElement(ink_1.Color, { blue: true }, "\u25BC "),
    shiftUp: React.createElement(ink_1.Color, { blue: true }, "SHIFT + \u25B2 "),
    shiftDown: React.createElement(ink_1.Color, { blue: true }, "SHIFT + \u25BC "),
    enter: React.createElement(ink_1.Color, { blue: true }, "ENTER "),
    space: React.createElement(ink_1.Color, { blue: true }, "SPACE ")
};
var description = (React.createElement(ink_1.Box, { width: '50%' },
    "Reorder and select the PDF files that you want to join. Use ",
    shortcutInfos.up,
    " and ",
    shortcutInfos.down,
    " to scroll through the list, ",
    shortcutInfos.shiftUp,
    " and ",
    shortcutInfos.shiftDown,
    " to move items, ",
    shortcutInfos.space,
    " to select or deselect items and ",
    shortcutInfos.enter,
    "to finalize."));
var List = /** @class */ (function (_super) {
    __extends(List, _super);
    function List(props) {
        var _this = _super.call(this, props) || this;
        _this.handleMovement = function (direction, shift, ctrl) {
            if (shift) {
                _this.reorder(_this.state.position, direction);
            }
            _this.setState({ position: _this.state.position + direction });
        };
        _this.toggleItem = function () {
            _this.setState({
                list: _this.state.list.map(function (item, index) { return index !== _this.state.position ? item : __assign({}, item, { active: !item.active }); })
            });
        };
        _this.reorder = function (position, relativeMovement) {
            if (relativeMovement > 0) {
                _this.setState({
                    list: _this.state.list.filter(function (item, index) { return index < position; }).concat(_this.state.list.filter(function (item, index) { return index > position && index <= position + relativeMovement; }), [
                        _this.state.list[position]
                    ], _this.state.list.filter(function (item, index) { return index > position + relativeMovement; }))
                });
            }
            else {
                _this.setState({
                    list: _this.state.list.filter(function (item, index) { return index < position + relativeMovement; }).concat([
                        _this.state.list[position]
                    ], _this.state.list.filter(function (item, index) { return index >= position + relativeMovement && index < position; }), _this.state.list.filter(function (item, index) { return index > position; }))
                });
            }
        };
        process.stdin.on('keypress', function (str, key) {
            if (key.ctrl && key.name === 'c') {
                process.exit();
            }
            if (key.name === 'up' || key.name === 'down') {
                _this.handleMovement(key.name === 'up' ? -1 : 1, key.shift, key.ctrl);
            }
            if (key.name === 'space' || key.name === 'right' || key.name === 'left') {
                _this.toggleItem();
            }
            if (key.name === 'return') {
                _this.props.onComplete(_this.state.list.filter(function (i) { return i.active; }).map(function (i) { return i.name; }));
            }
        });
        _this.state = {
            list: props.paths.map(function (p) { return ({ name: p, active: true }); }),
            position: 0
        };
        return _this;
    }
    List.prototype.render = function () {
        var _this = this;
        return (React.createElement(React.Fragment, null,
            description,
            this.state.list.map(function (item, index) { return (React.createElement(ink_1.Box, { width: "100%", key: item.name },
                React.createElement(ink_1.Box, null, index === _this.state.position ? ' > ' : '   '),
                React.createElement(ink_1.Box, null,
                    index + 1,
                    ". "),
                React.createElement(ink_1.Box, null, item.active ? '[X] ' : '[_] '),
                React.createElement(ink_1.Box, null, item.active ? item.name : React.createElement(ink_1.Color, { gray: true }, item.name)))); }),
            description));
    };
    return List;
}(React.Component));
exports.List = List;
//# sourceMappingURL=List.js.map