"use strict";
exports.__esModule = true;
var React = require("react");
var ink_1 = require("ink");
var fs = require("fs");
var path = require("path");
var react_1 = require("react");
var findInDir = function (dir, foundFile) {
    var contents = fs.readdirSync(dir);
    contents.forEach(function (file) {
        var filePath = path.join(dir, file);
        if (file.endsWith('.pdf')) {
            foundFile(filePath);
        }
        else if (fs.lstatSync(filePath).isDirectory()) {
            findInDir(filePath, foundFile);
        }
    });
};
exports.PdfFinder = function (props) {
    var _a = react_1.useState(0), count = _a[0], setCount = _a[1];
    var paths = react_1.useRef([]);
    var cwd = process.cwd();
    react_1.useEffect(function () {
        findInDir(cwd, function (file) {
            paths.current.push(file);
            setCount(count + 1);
        });
        props.onComplete(paths.current);
    }, []);
    return (React.createElement(React.Fragment, null,
        React.createElement(ink_1.Box, { width: "100%" },
            "Found ",
            React.createElement(ink_1.Color, { blueBright: true }, paths.current.length),
            " in ",
            React.createElement(ink_1.Color, { blueBright: true }, cwd),
            "..."),
        paths.current
            .reverse()
            .filter(function (item, index) { return index < 4; })
            .map(function (dir) { return React.createElement(ink_1.Box, { key: dir, width: "100%" },
            "  ",
            dir); })));
};
//# sourceMappingURL=PdfFinder.js.map